Subject: RE: [PATCH]NET: Add ECN support for TSO

From: "Ravinandan Arakali" <[email-masked]>
Date: Tue, 11 Jul 2006 18:45:48 -0700

Michael/David,
Thanks for the comments on LRO. The current LRO code in S2io driver is not
aware of ECN. While I was trying to fix this, the first thing I encountered
was to check, in the driver, if ECN is enabled for current session. To do
this, I try to get hold of the socket by doing something like:

tk = tcp_sk(skb->sk);
if (tk->ecn_flags & TCP_ECN_OK)
   /* Check CE, ECE, CWR etc */

I find that skb->sk is NULL. Is this the correct way to check the
per-session
ECN capability ? Why is skb->sk NULL ?

Thanks,
Ravi

-----Original Message-----
From: David Miller [mailto:[email-masked]]
Sent: Saturday, July 08, 2006 1:32 PM
To: [email-masked]
Cc: [email-masked]; [email-masked];
[email-masked]
Subject: Re: [PATCH]NET: Add ECN support for TSO

From: "Michael Chan" <[email-masked]>
Date: Fri, 7 Jul 2006 18:01:34 -0700

> However, Large Receive Offload will be a different story.  If
> packets are accumulated in the hardware and presented to the stack
> as one large packet, the stack will not be able to calculate the
> cumulative NS correctly.  Unless the hardware calculates the partial
> NS over the LRO packet and puts it in the SKB when handing over the
> packet.

This is correct, LRO hardware would need to do something to make sure
the nonce parity works out.